<template>
	<div :id="id" :class="[$style.block, { [$style.onlyOne]: productsNormalized.length < 2 }]">
		<div :class="$style.blockInner">
			<h2
				v-if="heading"
				class="u-heading u-heading--pre-line"
				:class="[$style.heading, { [$style.hasSubheadingBelow]: subheading }]"
			>
				{{ heading }}
			</h2>
			<h3 v-if="subheading" :class="$style.subheading">{{ subheading }}</h3>
			<div :class="$style.row">
				<div :class="[$style.col, $style.colDescription]">
					<p :class="$style.description">{{ description }}</p>
				</div>
				<div :class="[$style.col, $style.colProducts]">
					<div :class="$style.products">
						<div
							v-for="(product, index) in productsNormalized"
							:key="index"
							:class="[$style.product, { [$style.set3]: productsNormalized.length % 3 === 0 }]"
						>
							<div :class="$style.productTop">
								<h3 :class="$style.productName">{{ product.name }}</h3>
								<p v-if="product.discount" :class="$style.discount">{{
									`— Save ${currencyDisplay}${product.discount} —`
								}}</p>
								<div v-if="product.productOrBundle" :class="$style.productPriceWrapper">
									<MoleculeProductPrice
										:current-price="product.productOrBundle.currentPrice"
										:list-price="product.productOrBundle.listPrice"
										:affirm="product.enableAffirm"
									/>
								</div>
								<div v-if="product.ctaLink && product.ctaLink.url" :class="$style.buttonWrapper">
									<BaseButton
										:smart="product.ctaLink.url"
										:target="product.ctaLink.target"
										size="medium"
										appearance="primary"
									>
										{{ product.ctaText || product.ctaLink.url }}
									</BaseButton>
								</div>
							</div>
							<div :class="$style.productImageWrapper">
								<BaseImage
									:image="product.mobileImage"
									:images="{ medium: product.desktopImage }"
									compression-level="medium"
									sizes="(min-width: 768px) 380px, calc(100vw - 40px)"
									:critical="critical"
								/>
								<BlockWatermark
									v-if="product.watermarkImageDesktop"
									:critical="critical"
									:image="product.watermarkImageMobile"
									:images="product.watermarkImageDesktop"
									:watermark-height="product.watermarkHeight || 50"
									:watermark-width="product.watermarkWidth || 100"
									:watermark-opacity="product.watermarkOpacity"
									:watermark-position="product.watermarkPosition || 'Center'"
								/>
							</div>
						</div>
					</div>
				</div>
			</div>
		</div>
	</div>
</template>

<script>
import { mapState } from 'vuex';
import MoleculeProductPrice from '@components/molecule-product-price';
import BlockWatermark from '@components/block-watermark';

export default {
	components: {
		MoleculeProductPrice,
		BlockWatermark,
	},

	props: {
		id: {
			type: String,
			default: null,
		},

		heading: {
			type: String,
			default: '',
		},

		subheading: {
			type: String,
			default: '',
		},

		description: {
			type: String,
			default: '',
		},

		items: {
			type: Array,
			default: () => [],
		},

		critical: {
			type: Boolean,
			default: false,
		},

		productsNormalized: {
			type: Array,
			default: () => [],
		},
	},
	computed: {
		...mapState(['currencyDisplay']),
	},
};
</script>

<style lang="scss" module>
@import '@design';

.block {
	padding: size('xl') 0 0;
	background-color: #f7f6f6;

	@include above('xlarge') {
		padding: size('xxl') 0 0;
	}
}

.blockInner {
	max-width: 60rem;
	padding: 0 size('s');
	margin: 0 auto;

	@include above('large') {
		max-width: 138rem;
	}
}

.row {
	display: flex;
	flex-wrap: wrap;
	margin: 0 size('xxs') * -1;
}

@mixin columns($bp) {
	&.colDescription {
		margin-bottom: size('m');
		text-align: center;

		@include above($bp) {
			width: 32%;
			margin-bottom: 0;
			text-align: left;
		}
	}

	&.colProducts {
		@include above($bp) {
			width: 100% - 32%;
		}
	}
}

.col {
	flex: 0 0 auto;
	width: 100%;
	padding: 0 size('s') / 2;

	@include columns('large');

	.onlyOne & {
		@include columns('medium');
	}
}

.description {
	@include use-text-style('heading-100');
	@include use-text-style('type');

	font-weight: 300;
	white-space: pre-line;

	@include above('large') {
		max-width: 34rem;
	}
}

.heading {
	&.hasSubheadingBelow {
		margin-bottom: 1rem;
	}
}

.subheading {
	@include use-text-style('heading-100');

	margin-bottom: 3.6rem;
	font-weight: 300;
	line-height: 1.6;
	text-align: center;
	white-space: pre-line;

	@include above('medium') {
		white-space: normal;
	}
}

.products {
	display: flex;
	flex-wrap: wrap;
	justify-content: space-around;
}

.product {
	display: flex;
	flex: 0 1 auto;
	flex-direction: column;
	width: 100%;
	max-width: 40rem;
	text-align: center;

	@include above('medium') {
		flex-grow: 1;
		width: 0;
		padding: 0 size('xxs');
	}

	@include above('large') {
		// styles we have above for medium are breaking on IE
		flex-grow: 0;
		width: 50%;

		&.set3 {
			width: 33%;
		}
	}

	&:not(:last-child) {
		@include below('medium') {
			margin-bottom: size('m');
		}
	}
}

.productTop {
	flex-grow: 1;
	padding-bottom: size('s');
}

.productName {
	@include font-family('secondary');
	@include use-text-style('heading-200');

	margin-bottom: size('xxs');
}

.discount {
	@include use-text-style('type-500');

	margin: 0 0 1rem;
	font-weight: 300;
	color: color('primary');
}

.productPriceWrapper {
	display: flex;
	justify-content: center;
	margin-bottom: size('s');
}

.productImageWrapper {
	position: relative;
}
</style>
